--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 10.1.03
--  \   \         Application : ISE
--  /   /         Filename : pb_outreg_test.vhw
-- /___/   /\     Timestamp : Tue Jun 02 18:44:32 2009
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: pb_outreg_test
--Device: Xilinx
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
library UNISIM;
use UNISIM.VComponents.all;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY pb_outreg_test IS
END pb_outreg_test;

ARCHITECTURE testbench_arch OF pb_outreg_test IS
    FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";

    COMPONENT pb_outreg
        PORT (
            write_strobe : In std_logic;
            pb_clk : In std_logic;
            port_sel : In std_logic_vector (2 DownTo 0);
            Q0 : Out std_logic_vector (7 DownTo 0);
            Q1 : Out std_logic_vector (7 DownTo 0);
            Q2 : Out std_logic_vector (7 DownTo 0);
            Q3 : Out std_logic_vector (7 DownTo 0);
            Q4 : Out std_logic_vector (7 DownTo 0);
            Q5 : Out std_logic_vector (7 DownTo 0);
            Q6 : Out std_logic_vector (7 DownTo 0);
            Q7 : Out std_logic_vector (7 DownTo 0);
            S0 : Out std_logic;
            S1 : Out std_logic;
            S2 : Out std_logic;
            S3 : Out std_logic;
            S4 : Out std_logic;
            S5 : Out std_logic;
            S6 : Out std_logic;
            S7 : Out std_logic;
            port_d : In std_logic_vector (7 DownTo 0)
        );
    END COMPONENT;

    SIGNAL write_strobe : std_logic := '0';
    SIGNAL pb_clk : std_logic := '0';
    SIGNAL port_sel : std_logic_vector (2 DownTo 0) := "000";
    SIGNAL Q0 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL Q1 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL Q2 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL Q3 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL Q4 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL Q5 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL Q6 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL Q7 : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL S0 : std_logic := '0';
    SIGNAL S1 : std_logic := '0';
    SIGNAL S2 : std_logic := '0';
    SIGNAL S3 : std_logic := '0';
    SIGNAL S4 : std_logic := '0';
    SIGNAL S5 : std_logic := '0';
    SIGNAL S6 : std_logic := '0';
    SIGNAL S7 : std_logic := '0';
    SIGNAL port_d : std_logic_vector (7 DownTo 0) := "00000000";

    constant PERIOD : time := 200 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 100 ns;

    BEGIN
        UUT : pb_outreg
        PORT MAP (
            write_strobe => write_strobe,
            pb_clk => pb_clk,
            port_sel => port_sel,
            Q0 => Q0,
            Q1 => Q1,
            Q2 => Q2,
            Q3 => Q3,
            Q4 => Q4,
            Q5 => Q5,
            Q6 => Q6,
            Q7 => Q7,
            S0 => S0,
            S1 => S1,
            S2 => S2,
            S3 => S3,
            S4 => S4,
            S5 => S5,
            S6 => S6,
            S7 => S7,
            port_d => port_d
        );

        PROCESS    -- clock process for pb_clk
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                pb_clk <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                pb_clk <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            BEGIN
                -- -------------  Current Time:  185ns
                WAIT FOR 185 ns;
                port_d <= "01010101";
                -- -------------------------------------
                -- -------------  Current Time:  385ns
                WAIT FOR 200 ns;
                write_strobe <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  585ns
                WAIT FOR 200 ns;
                write_strobe <= '0';
                port_d <= "01110111";
                -- -------------------------------------
                -- -------------  Current Time:  785ns
                WAIT FOR 200 ns;
                write_strobe <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  985ns
                WAIT FOR 200 ns;
                write_strobe <= '0';
                -- -------------------------------------
                WAIT FOR 1215 ns;

            END PROCESS;

    END testbench_arch;

