----------------------------------------------------------------------------------
-- Company: c't-Lab
-- Engineer: Carsten Meyer
-- 
-- Create Date:    24.05.2009 
-- Design Name: 
-- Module Name:    pb_outreg - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: Port Decoder $4x for Picoblaze Core
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity pb_outreg is
    Port ( write_strobe: in STD_LOGIC;
			pb_clk: in STD_LOGIC;
			  port_sel : in STD_LOGIC_VECTOR (7 downto 0);
           Q0 : out  STD_LOGIC_VECTOR (7 downto 0);
           Q1 : out  STD_LOGIC_VECTOR (7 downto 0);
           Q2 : out  STD_LOGIC_VECTOR (7 downto 0);
           Q3 : out  STD_LOGIC_VECTOR (7 downto 0);
           Q4 : out  STD_LOGIC_VECTOR (7 downto 0);
           Q5 : out  STD_LOGIC_VECTOR (7 downto 0);
           Q6 : out  STD_LOGIC_VECTOR (7 downto 0);
           Q7 : out  STD_LOGIC_VECTOR (7 downto 0);
			  S0 : out  STD_LOGIC;
			  S1 : out  STD_LOGIC;
			  S2 : out  STD_LOGIC;
			  S3 : out  STD_LOGIC;
			  S4 : out  STD_LOGIC;
			  S5 : out  STD_LOGIC;
			  S6 : out  STD_LOGIC;
			  S7 : out  STD_LOGIC;
           port_d : in STD_LOGIC_VECTOR (7 downto 0) );
end pb_outreg;

architecture Behavioral of pb_outreg is
	signal write_strobe_del: std_logic;

begin
--S0<= '1' when (write_strobe_del='1' and port_sel="000") else '0';
--S1<= '1' when (write_strobe_del='1' and port_sel="001") else '0';
--S2<= '1' when (write_strobe_del='1' and port_sel="010") else '0';
--S3<= '1' when (write_strobe_del='1' and port_sel="011") else '0';
--S4<= '1' when (write_strobe_del='1' and port_sel="100") else '0';
--S5<= '1' when (write_strobe_del='1' and port_sel="101") else '0';
--S6<= '1' when (write_strobe_del='1' and port_sel="110") else '0';
--S7<= '1' when (write_strobe_del='1' and port_sel="111") else '0';
		
process(write_strobe, pb_clk, port_sel)
	begin  
		if rising_edge(pb_clk) then
			write_strobe_del<=write_strobe;
			S0 <= '0';
			S1 <= '0';
			S2 <= '0';
			S3 <= '0';
			S4 <= '0';
			S5 <= '0';
			S6 <= '0';
			S7 <= '0';
			case port_sel is
			when x"40" =>
				S0 <= write_strobe; 
			when x"41" =>
				S1 <= write_strobe; 
			when x"42" =>
				S2 <= write_strobe; 
			when x"43" =>
				S3 <= write_strobe; 
			when x"44" =>
				S4 <= write_strobe; 
			when x"45" =>
				S5 <= write_strobe; 
			when x"46" =>
				S6 <= write_strobe; 
			when x"47" =>
				S7 <= write_strobe; 
			when others =>
			end case;
			if write_strobe='1' then
				case port_sel is
				when x"40" =>
					Q0 <= port_d; 
				when x"41" =>
					Q1 <= port_d; 
				when x"42" =>
					Q2 <= port_d; 
				when x"43" =>
					Q3 <= port_d; 
				when x"44" =>
					Q4 <= port_d; 
				when x"45" =>
					Q5 <= port_d; 
				when x"46" =>
					Q6 <= port_d; 
				when x"47" =>
					Q7 <= port_d; 
				when others =>
				end case;
			end if;
		end if;
	end process;

end Behavioral;

